const express = require("express");
const bodyParser = require("body-parser");
const path = require("path");
const cookieParser = require("cookie-parser");

const application = express();
application.use(cookieParser());

// use middleWare for render my css files and image
application.use(express.urlencoded({ extended: true }));
application.use(express.static(path.join(__dirname, "public")));

// use body parser to access body elements
application.use(bodyParser.json());
// create users with array because I want save in a array
const users = [];
// this is login path if in url write login , show login.html to you
application.get("/login", (request, response) => {
  response.sendFile(path.join(__dirname + "/views/login.html"));
});
// when you write name in login form , push name in users array with POST method
application.post("/userlogin", (request, response) => {
  users.push({
    name: request.body.name,
  });
  // save name in cookie because if reopen browser doesn't clear name and after that redirect to home
  response.cookie("name", request.body.name);
  response.redirect("/");
});

application.get("/", (request, response) => {
  var key = request.cookies;
  // becareful this code clear yor cookie
  // response.clearCookie("name");

  // this code check if key does'nt undefined response send name of user else redirect to login form
  if (key.name !== undefined) {
    response.send(`Hi ${key.name}`);
  } else {
    response.redirect("/login");
  }
  console.log(request.cookies);
});
// show users after reopen browser
application.get("/users", (request, response) => {
  return response.json(request.cookies);
});
const startApplication = () => {
  application.listen(8000, () => {
    console.log("application is runnig...");
  });
};

module.exports = startApplication;
